#
# This script was written by David Kyger <david_kyger@symantec.com>
#
# See the Nessus Scripts License for details
#

if(description)
{
  script_id(12049);
  script_version ("$Revision: 1.2 $");
# script_bugtraq_id();
# script_cve_id("");

 name["english"] = "Default Novonyx Web Server Files ";
 script_name(english:name["english"]);
 
 desc["english"] = "
Novell Netware default Novonyx web server files

A default installation of Novell 5.x will install the Novonyx web server. 
Numerous web server files included with this installation could reveal 
sensitive information.

Solution : Delete the default pages
Risk Factor : Medium";  


 script_description(english:desc["english"]);
 
 summary["english"] = "Checks for default Novonyx web server files";
 
 script_summary(english:summary["english"]);
 
 script_category(ACT_GATHER_INFO);
 script_copyright(english:"This script is Copyright (C) 2004 David Kyger");
 family["english"] = "Netware";
 script_family(english:family["english"]);
 script_dependencie("find_service.nes", "http_version.nasl");
 script_require_ports("Services/www", 80);
 exit(0);
}

#
# The script code starts here
#
include("http_func.inc");
include("http_keepalive.inc");


flag = 0;

warning = string("
A default installation of Novell 5.x will install the Novonyx web server. 
Numerous web server files included with this installation could reveal 
sensitive information.  

The following Novonyx web server files were found on the server:");

port = get_kb_item("Services/www");
if(!port)port=80;
if(get_port_state(port)) {

   fl[0] = "/netbasic/websinfo.bas";
   fl[1] = "/lcgi/sewse.nlm?sys:/novonyx/suitespot/docs/sewse/misc/allfield.jse";
   fl[2] = "/perl/samples/lancgi.pl";
   fl[3] = "/perl/samples/ndslogin.pl";
   fl[4] = "/perl/samples/volscgi.pl";
   fl[5] = "/perl/samples/env.pl";
   fl[6] = "/nsn/env.bas";
   fl[7] = "/nsn/fdir.bas";

 
   for(i=0;fl[i];i=i+1) 
   { 
    if(is_cgi_installed_ka(item:fl[i], port:port)) 
	{
        warning = warning + string("\n", fl[i]); 
        flag = 1;
        }
   }
    if (flag > 0) {
	warning += string("\n\nSolution : If not required, remove all default Novonyx web server files\n");
        warning += string("Risk Factor : Medium");
        security_warning(port:port, data:warning);
        } else {
          exit(0);
        }
}


